searchData={"items":[{"type":"module","title":"Phoenix.SessionProcess","doc":"Documentation for `Phoenix.SessionProcess`.\n\nAdd superviser to process tree\n\n    [\n      ...\n      {Phoenix.SessionProcess.Supervisor, []}\n    ]\n\nAdd this after the `:fetch_session` plug to generate a unique session ID.\n\n    plug :fetch_session\n    plug Phoenix.SessionProcess.SessionId\n\nStart a session process with a session ID.\n\n    Phoenix.SessionProcess.start(\"session_id\")\n\nThis will start a session process using the module defined with\n\n    config :phoenix_session_process, session_process: MySessionProcess\n\nOr you can start a session process with a specific module.\n\n    Phoenix.SessionProcess.start(\"session_id\", MySessionProcess)\n    # or\n    Phoenix.SessionProcess.start(\"session_id\", MySessionProcess, arg)\n\nCheck if a session process is started.\n\n    Phoenix.SessionProcess.started?(\"session_id\")\n\nTerminate a session process.\n\n    Phoenix.SessionProcess.terminate(\"session_id\")\n\nGenserver call on a session process.\n\n    Phoenix.SessionProcess.call(\"session_id\", request)\n\nGenserver cast on a session process.\n\n    Phoenix.SessionProcess.cast(\"session_id\", request)\n\nList all session processes.\n\n    Phoenix.SessionProcess.list_session()","ref":"Phoenix.SessionProcess.html"},{"type":"function","title":"Phoenix.SessionProcess.call/3","doc":"","ref":"Phoenix.SessionProcess.html#call/3"},{"type":"function","title":"Phoenix.SessionProcess.cast/2","doc":"","ref":"Phoenix.SessionProcess.html#cast/2"},{"type":"function","title":"Phoenix.SessionProcess.list_session/0","doc":"","ref":"Phoenix.SessionProcess.html#list_session/0"},{"type":"function","title":"Phoenix.SessionProcess.start/1","doc":"","ref":"Phoenix.SessionProcess.html#start/1"},{"type":"function","title":"Phoenix.SessionProcess.start/2","doc":"","ref":"Phoenix.SessionProcess.html#start/2"},{"type":"function","title":"Phoenix.SessionProcess.start/3","doc":"","ref":"Phoenix.SessionProcess.html#start/3"},{"type":"function","title":"Phoenix.SessionProcess.started?/1","doc":"","ref":"Phoenix.SessionProcess.html#started?/1"},{"type":"function","title":"Phoenix.SessionProcess.terminate/1","doc":"","ref":"Phoenix.SessionProcess.html#terminate/1"},{"type":"module","title":"Phoenix.SessionProcess.ProcessSupervisor","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.call_on_session/3","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#call_on_session/3"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.cast_on_session/2","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#cast_on_session/2"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.child_name/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#child_name/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#child_spec/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.session_process_pid/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#session_process_pid/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.session_process_started?/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#session_process_started?/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.start_child/2","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#start_child/2"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.start_link/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#start_link/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.start_session/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#start_session/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.start_session/2","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#start_session/2"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.start_session/3","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#start_session/3"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.terminate_child/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#terminate_child/1"},{"type":"function","title":"Phoenix.SessionProcess.ProcessSupervisor.terminate_session/1","doc":"","ref":"Phoenix.SessionProcess.ProcessSupervisor.html#terminate_session/1"},{"type":"module","title":"Phoenix.SessionProcess.SessionId","doc":"Documentation for `Phoenix.SessionProcess.SessionId`.\n\nAdd this after the `:fetch_session` plug to generate a unique session ID.\n\n    plug :fetch_session\n    plug Phoenix.SessionProcess.SessionId","ref":"Phoenix.SessionProcess.SessionId.html"},{"type":"function","title":"Phoenix.SessionProcess.SessionId.generate_unique_session_id/0","doc":"","ref":"Phoenix.SessionProcess.SessionId.html#generate_unique_session_id/0"},{"type":"module","title":"Phoenix.SessionProcess.Supervisor","doc":"","ref":"Phoenix.SessionProcess.Supervisor.html"},{"type":"function","title":"Phoenix.SessionProcess.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Phoenix.SessionProcess.Supervisor.html#child_spec/1"},{"type":"function","title":"Phoenix.SessionProcess.Supervisor.start_link/1","doc":"","ref":"Phoenix.SessionProcess.Supervisor.html#start_link/1"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.3.1 (30 Sep 2024) - Changelog","doc":"* Fix bug.","ref":"changelog.html#0-3-1-30-sep-2024"},{"type":"extras","title":"0.3.0 (30 Sep 2024) - Changelog","doc":"* Add get_session_id in process.","ref":"changelog.html#0-3-0-30-sep-2024"},{"type":"extras","title":"0.2.0 (5 Feb 2024) - Changelog","doc":"* Add list_sessions and process_monitor macro.","ref":"changelog.html#0-2-0-5-feb-2024"},{"type":"extras","title":"0.1.0 (5 Feb 2024) - Changelog","doc":"* Create package.","ref":"changelog.html#0-1-0-5-feb-2024"},{"type":"extras","title":"Phoenix.SessionProcess","doc":"# Phoenix.SessionProcess\n\nCreate a process for each session, all user requests would through this process.\n\n* [Github Repo](https://github.com/gsmlg-dev/phoenix_session_process)","ref":"readme.html"},{"type":"extras","title":"Installation - Phoenix.SessionProcess","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `phoenix_session_process` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_session_process, \"~> 0.4.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"How to - Phoenix.SessionProcess","doc":"Add superviser to process tree\n\n```elixir\n    [\n      ...\n      {Phoenix.SessionProcess.Supervisor, []}\n    ]\n```\n\nAdd this after the `:fetch_session` plug to generate a unique session ID.\n\n```elixir\n    plug :fetch_session\n    plug Phoenix.SessionProcess.SessionId\n```\n\nStart a session process with a session ID.\n\n```elixir\n    Phoenix.SessionProcess.start(\"session_id\")\n```\n\nThis will start a session process using the module defined with\n\n```elixir\n    config :phoenix_session_process, session_process: MySessionProcess\n```\n\nDefine MySessionProcess\n\n```elixir\ndefmodule MySessionProcess do\n  @doc \"\"\"\n  The use macro is expanded as\n\n      use GenServer\n\n      def start_link(name: name, arg: arg) do\n        GenServer.start_link(__MODULE__, arg, name: name)\n      end\n      def start_link(name: name) do\n        GenServer.start_link(__MODULE__, %{}, name: name)\n      end\n  \"\"\"\n  use Phoenix.SessionProcess, :process\nend\n\n# with monitor live view\ndefmodule MySessionProcessWithMonitor do\n  @doc \"\"\"\n  The use macro is expanded as\n\n      use GenServer\n\n      def start_link(name: name, arg: arg) do\n        GenServer.start_link(__MODULE__, arg, name: name)\n      end\n      def start_link(name: name) do\n        GenServer.start_link(__MODULE__, %{}, name: name)\n      end\n\n      @impl true\n      def init(arg) do\n        Process.flag(:trap_exit, true)\n\n        {:ok, state}\n      end\n\n      @impl true\n      def handle_call(:get_state, _from, state) do\n        {:reply, state, state}\n      end\n\n      @impl true\n      def handle_cast({:monitor, pid}, state) do\n        state = state |> Map.update(:__live_view__, [pid], fn views -> [pid | views] end)\n        Process.monitor(pid)\n        {:noreply, state}\n      end\n\n      @impl true\n      def handle_info({:DOWN, _ref, :process, pid, _reason}, state) do\n        state = state |> Map.update(:__live_view__, [], fn views -> views |> Enum.filter(&(&1 != pid)) end)\n\n        {:noreply, state}\n      end\n\n      @impl true\n      def terminate(reason, state) do\n        state\n        |> Map.get(:__live_view__, [])\n        |> Enum.each(&Process.send_after(&1, :session_expired, 0))\n      end\n\n  In live view\n\n      def mount(_params, %{\"session_id\" => session_id} = _session, socket) do\n        socket = socket\n        |> assign(:session_id, session_id)\n\n        Phoenix.SessionProcess.cast(session_id, {:monitor, self()})\n\n        {:ok, socket}\n      end\n\n      # trap session expires\n      def handle_info(:session_expired, socket) do\n        {:noreply, socket |> redirect(to: @sign_in_page)}\n      end\n  \"\"\"\n  use Phoenix.SessionProcess, :process\nend\n```\n\nOr you can start a session process with a specific module.\n\n```elixir\n    Phoenix.SessionProcess.start(\"session_id\", MySessionProcess)\n    # or\n    Phoenix.SessionProcess.start(\"session_id\", MySessionProcess, arg)\n```\n\nCheck if a session process is started.\n\n```elixir\n    Phoenix.SessionProcess.started?(\"session_id\")\n```\n\nTerminate a session process.\n\n```elixir\n    Phoenix.SessionProcess.terminate(\"session_id\")\n```\n\nGenserver call on a session process.\n\n```elixir\n    Phoenix.SessionProcess.call(\"session_id\", request)\n```\n\nGenserver cast on a session process.\n\n```elixir\n    Phoenix.SessionProcess.cast(\"session_id\", request)\n```\n\nGet session id in SessionProcess.\n\n```elixir\n    get_session_id()\n```","ref":"readme.html#how-to"}],"content_type":"text/markdown"}